
class BaseInterface:
  '''
  This interface handles reference counting and reflection
  - Every interface in <code>SIDL</code> implicitly inherits from <code>BaseInterface</code>
  '''
  
  def __init__(self, obj):
    '''
    This interface handles reference counting and reflection
    - Every interface in <code>SIDL</code> implicitly inherits from <code>BaseInterface</code>
    '''
    self.obj = obj
  
  def __eq__(self, obj):
    if not hasattr(obj, 'obj'):
      return 0
    return self.isSame(obj)
  
  def __getattr__(self, attr):
    '''
    Every call to the interface is dispatched to the underlying class
    '''
    return getattr(self.obj, attr)
  
  def weakReference(self):
    return self
